.TH CLASS-DUMP L "July 9, 1993" "San Francisco State University"
.\" Copyright 1991, 1992, 1993 by Eric P. Scott
.\" class-dump release 1.3
.SH NAME
class-dump \- dump Objective-C class, category, and protocol information
.SH SYNOPSIS
.B class-dump
[
.B \-a
] [
.B \-e
] [
.B \-R
] [
.B \-C
.I regex
]
executable-file
.SH DESCRIPTION
.if t .ad b
.I Class-dump
produces a listing of the classes, categories, protocols,
instance variables, and methods known to an Objective-C
executable or shared library.  The output resembles the
declarations used in .h files.
.PP
The
.B \-a
option additionally displays instance variable offsets and method
implementation addresses.
.PP
.B \-e
expands structures and unions when possible.  Produces copious
output of questionable value.  Does nothing with pre-3.0
executables.
.PP
.B \-R
recursively displays incorporated protocols.  Not applicable to
pre-3.0 executables.
.PP
The
.B
\-C
option limits class and category display to classes matching the
specified regular expression.
.SH AUTHOR
Eric P. Scott
.SH "SEE ALSO"
grep(1), otool(1)
.SH BUGS
Doesn't work on pre-2.0 executables.
.PP
Doesn't work on relocatables.  (You aren't likely to run into
these, except as part of NXBundles.)
.PP
Sometimes displays incorrect data types.  For example, BOOL
appears as char, NXAtom appears as STR, function pointers and
complex declarations may appear as UNKNOWN or ?.  Due to a
longstanding compiler bug, long long (64-bit integer) data types
may be problematic, and unsigned long long cannot be
distinguished.  (Believed to fixed by gcc 2.4.4)
.PP
Doesn't pretty-print or wrap long lines.
.PP
Corrupt executables may result in core dumps.
.PP
Doesn't display <protocols> on @interface line.
.PP
The
.B \-R
option should probably be removed, with recursive display always
performed.
.PP
Should use something more sophisticated than regex(3) for regular
expression support.
.PP
Can't discern @private/@protected/@public.
.PP
It is not possible to examine an i486 executable on a m68k
machine.  Only the native subfile of a
.if t ``fat''
.if n "fat"
binary can be accessed.
